# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class AipInfoEmbargo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'access': 'str',
        'months': 'float',
        'start_date': 'str'
    }

    attribute_map = {
        'access': 'access',
        'months': 'months',
        'start_date': 'startDate'
    }

    def __init__(self, access=None, months=None, start_date=None, local_vars_configuration=None):  # noqa: E501
        """AipInfoEmbargo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._access = None
        self._months = None
        self._start_date = None
        self.discriminator = None

        if access is not None:
            self.access = access
        if months is not None:
            self.months = months
        if start_date is not None:
            self.start_date = start_date

    @property
    def access(self):
        """Gets the access of this AipInfoEmbargo.  # noqa: E501

        Starting date of embargo period  # noqa: E501

        :return: The access of this AipInfoEmbargo.  # noqa: E501
        :rtype: str
        """
        return self._access

    @access.setter
    def access(self, access):
        """Sets the access of this AipInfoEmbargo.

        Starting date of embargo period  # noqa: E501

        :param access: The access of this AipInfoEmbargo.  # noqa: E501
        :type: str
        """

        self._access = access

    @property
    def months(self):
        """Gets the months of this AipInfoEmbargo.  # noqa: E501

        Month number of embargo duration  # noqa: E501

        :return: The months of this AipInfoEmbargo.  # noqa: E501
        :rtype: float
        """
        return self._months

    @months.setter
    def months(self, months):
        """Sets the months of this AipInfoEmbargo.

        Month number of embargo duration  # noqa: E501

        :param months: The months of this AipInfoEmbargo.  # noqa: E501
        :type: float
        """

        self._months = months

    @property
    def start_date(self):
        """Gets the start_date of this AipInfoEmbargo.  # noqa: E501

        Starting date of embargo period  # noqa: E501

        :return: The start_date of this AipInfoEmbargo.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this AipInfoEmbargo.

        Starting date of embargo period  # noqa: E501

        :param start_date: The start_date of this AipInfoEmbargo.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AipInfoEmbargo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AipInfoEmbargo):
            return True

        return self.to_dict() != other.to_dict()
